Extra debug information added to md5sum check failure. Changed dd count= option to...
[backups/.git] / scripts / burn-imgs.sh
index 81cbee0b1e554b788efcadd96431ac47638e77c3..da5b11b911591dc15f2239bf663a8b5ae7dd96aa 100755 (executable)
@@ -1,51 +1,65 @@
 #!/bin/sh
 
-PATH=$(dirname $0):/bin:/usr/bin
+export PATH=$(dirname $0):/bin:/usr/bin:/sbin
 
+# source the default configuration
 . config.sh
 
+# source the system specific configuration
+[ -f /etc/lsbackups.conf ] && . /etc/lsbackups.conf
+
 # If the noburn file is there then don't burn.
 [ -f "$noburnfile" ] && exit 0
-touch $noburnfile
-
-# Discover disk images by looking for .img.md5sum files in $imagedir
-imgmd5=$(ls $imagedir/*.img.md5sum | head -n 1)
-
-echo MD5 file: $imgmd5
-
-logfile=$(tempfile)
 
-echo Logfile: $logfile
+# Discover disk images by looking for .iso.md5sum files in $imagedir
+imgmd5=$(ls $imagedir/*.iso.md5sum 2>/dev/null | head -n 1)
 
 # If we didn't find an non-empty file then exit gracefully
 [ -z "$imgmd5" ] && exit 0
 [ -s "$imgmd5" ] || exit 0
 
+logfile=$(tempfile)
+
 # Get the name of the disk image by stripping off the tailing '.md5sum'
 img=${imgmd5%.md5sum}
 
-echo Image: $img
+touch $noburnfile
 
 # A little paranoia.  Make sure the disk image file is there.
 [ -z "$img" ] && exit 1
 [ -s "$img" ] || exit 1
 
+# To avoid buffer underruns I'm going to stop cron and renice myself
+$cronstopstart stop
+renice -10 $$
+
 # Burn the image to a disk.
-cdrecord-wrapper.sh -dao dev=$sdev $img > $logfile 2>&1
+cdrecord-wrapper.sh $cdrecordopts dev=$sdev $img > $logfile 2>&1
 
 if [ "0" != "$?" ]; then
   echo >&2 "cdrecord failed!"
+  $cronstopstart start
+  cat $logfile | grep -v "MB written" | grep -v "to quit" | mailx -s "backups: failed to burn $img!!!" $mailto
   exit 1
 fi
 
+# We don't need to be high-priority anymore.
+renice 0 $$
+$cronstopstart start
+
+# I don't know if this *really* helps but give cdrecord a chance to clean up.
+sleep 60
+
 # Now verify the disk by running md5sum on the entire contents of the disk
 md5sum=$(tempfile)
-echo Md5sum: $md5sum
-dd if=$dev bs=1M count=4440 2>$logfile | md5sum | awk '{print$1}' > $md5sum
+dd if=$dev bs=1M count=$imagesizemb 2>>$logfile | md5sum | awk '{print$1}' > $md5sum
 
 # Check that the md5sums match
 if ! cmp $md5sum $img.md5sum; then
-  echo "Failed" | mailx -s "DVD md5sum doesn't match image file!!!" $mailto
+  echo "md5sum check FAILED" >> $logfile
+  echo "dd if=$dev bs=1M count=$imagesizemb 2>>$logfile | md5sum | awk '{print\$1}' > $md5sum" >> $logfile
+  e2label $dev >> $logfile
+  cat $logfile | grep -v "MB written" | grep -v "to quit" | mailx -s "DVD md5sum doesn't match image file!!!" $mailto
   exit 1
 fi
 
@@ -62,10 +76,10 @@ date >> $img.stat
   cat $img.stat
   echo
   cat $logfile
-} | mailx -s "DVD burned.  File as ${img%.*}" $mailto > $logfile 2>&1
+} | grep -v "MB written" | grep -v "to quit" | mailx -s "DVD burned.  File as $(basename ${img%.*})" $mailto > $logfile 2>&1
 
 # Two lines in the stat file indicate two successful burns.  Clean-up the image.
-if [ "$(wc -l $img.stat 2>/dev/null | awk '{print$1}')" == "2" ]; then
+if [ "$(wc -l $img.stat 2>/dev/null | awk '{print$1}')" == "$makeXcopies" ]; then
   # Burned the image twice.  Removing it and associated files!
   rm -f $img{,.md5sum,.stat}
   [ -d $img.mnt ] && rmdir $img.mnt